% **********************************************************
% uncomment the following two lines if using Octave; Change
% path to where python is located on local pc
% **********************************************************
%setenv PYTHON C:\ProgramData\Miniconda3\python.exe
%pkg load symbolic

% **********************************************************
% variables
% **********************************************************
Vs1 = 6;
Vs2 = 12;
Is1 = sym(2)/1e3;
Is2 = sym(4)/1e3;
Is3 = sym(6)/1e3;

R1  = 1e3;
R2  = 1e3;
R3  = 2e3;
R4  = 1e3;


% **********************************************************
% set symbolic symbols
% **********************************************************
syms Va Vb Vc Vd real

% **********************************************************
% system of equations
% **********************************************************
eq1 = (Va-Vb)/R1 - Is1 + (Va-Vd)/R2 - Is3 == 0;
eq2 = (Vb-Va)/R1 + Is1 + (Vd-Va)/R2 + Vb/R3 + Is2 + Vd/R4 == 0;
eq3 = Vb - Vc == Vs1;
eq4 = Vd - Vc == Vs2;

% **********************************************************
% set equations and variables; Note: the number of equations
% and the number of unknown variables should be the same; the
% order to unknown variables should be reserved: V1, V2, ...
% **********************************************************
eqns = [eq1, eq2, eq3, eq4];
vars = [Va, Vb, Vc, Vd];

% **********************************************************
% set up coefficient matrix for debugging
% **********************************************************
[C, S] = equationsToMatrix (eqns, vars)

% **********************************************************
% solve for unknow variables using matrix
% **********************************************************
V = inv(C) * S

% **********************************************************
% solve for unknow variables; the number of variable on the 
% left of the equation should be equal to the number of the
% unknown variables.
% **********************************************************
%[Va, Vb, Vc, Vd] = solve(eqns, vars)

% **********************************************************
% converting symbolic value to real values
% **********************************************************
%Va = double (Va)
%Vb = double (Vb)
%Vc = double (Vc)
%Vd = double (Vd)

% **********************************************************
% calculating other values
% **********************************************************
%Io = Vd/R4

