% **********************************************************
% uncomment the following two lines if using Octave; Change
% path to where python is located on local pc
% **********************************************************
%setenv PYTHON C:\ProgramData\Miniconda3\python.exe
%pkg load symbolic

% **********************************************************
% variables
% **********************************************************
Vs  = 12;
Is1 = sym(4)/1e3;
Is2 = sym(2)/1e3;

R1  = 1e3;
R2  = 1e3;
R3  = 1e3;
R4  = 1e3;
R5  = 1e3;
R6  = 1e3;

% **********************************************************
% set symbolic symbols
% **********************************************************
syms Va Vb Vc Vd real

% **********************************************************
% system of equations
% **********************************************************
eq1 = -Is1 + (Va-Vb)/R1 + (Vd-Vc)/R2 + Vd/R5 + Vd/(R3+R6) == 0;
eq2 = (Va-Vb)/R1 + Is2 + Vc/R4 + (Vc-Vd)/R2 == 0;
eq3 = Vc - Vb == Vs;
eq4 = Vd - Va == 2*Vc;

% **********************************************************
% set equations and variables; Note: the number of equations
% and the number of unknown variables should be the same; the
% order to unknown variables should be reserved: V1, V2, ...
% **********************************************************
eqns = [eq1, eq2, eq3, eq4];
vars = [Va, Vb, Vc, Vd];

% **********************************************************
% set up coefficient matrix for debugging
% **********************************************************
[C, S] = equationsToMatrix (eqns, vars)

% **********************************************************
% solve for unknow variables using matrix
% **********************************************************
v = inv(C) * S

% **********************************************************
% solve for unknow variables; the number of variable on the 
% left of the equation should be equal to the number of the
% unknown variables.
% **********************************************************
%[Va, Vb, Vc, Vd] = solve(eqns, vars)

% **********************************************************
% converting symbolic value to real values
% **********************************************************
%Va = double (Va)
%Vb = double (Vb)
%Vc = double (Vc)
%Vd = double (Vd)

%Vo = R6*Vd/(R3+R6)

